<?php
$berogui = '/usr/local/www/berogui';
require_once("$berogui/includes/Helper/Helper.php");
require_once("$berogui/includes/Helper/HelperPstn.php");

function getTones($input, $default) {
	if (preg_match('/^\[([-a-z0-9]+)\]$/', $input, $matched)) {
		return $matched[1];
	}
	return $default;
}

function rewriteTones($tones) {
	return "[$tones]";
}

$response = array();
$tones = getTones($_POST['tones'], 'de');

switch ($_POST['action']) {
	case 'delete':
		require_once("$berogui/misc/database.php");
		$ba = new beroAri();

		$ba->delete("DELETE FROM tones_custom WHERE name='$tones'");

		$query = $ba->select("SELECT gr FROM analog WHERE tones='[$tones]'");
		while ($entry = $ba->fetch_array($query, SQLITE_ASSOC)) {
			$ba->update("UPDATE analog SET tones='[de]' WHERE gr='{$entry['gr']}'");
		}
		$count = 0;
		$response['created'] = array_keys(HelperPstn::getTonesCustom($ba, null, $count));

		$new_custom = '';
		for ($i=1;$i<=$count+1; $i++) {
			$new_custom = "custom$i";
			if (!in_array($new_custom, $response['created'])) {
				$response['created'][] = $new_custom;
				break;
			}
		}

		$tones_loaded = Helper::parseIniFile('/usr/conf/isgw.tones');
		$credentials = $tones_loaded['de'];
		unset($tones_loaded['general']);

		$response['options'] = implode("/", array_merge(array_keys($tones_loaded), $response['created']));
		$response['created'] = implode("/", array_map('rewriteTones', array_diff($response['created'], array($new_custom))));

		Helper::activate(2);
		break;
	case 'switch':
		$oldtones = getTones($_POST['oldtones'], 'de');

		if (preg_match('/^custom[0-9]+$/', $tones)) {
			require_once("$berogui/misc/database.php");
			$ba = new beroAri();
			$tones_loaded = HelperPstn::getTonesCustom($ba);
			$response['created'] = implode("/", array_keys($tones_loaded));
			if (isset($tones_loaded[$tones])) {
				$credentials = $tones_loaded[$tones];
			}
			else if (isset($tones_loaded[$oldtones])) {
				$credentials = $tones_loaded[$oldtones];
			}	
			else {
				$old_loaded = Helper::parseIniFile('/usr/conf/isgw.tones');
				$credentials = $old_loaded[$oldtones];
			}
		}
		else {
			$tones_loaded = Helper::parseIniFile('/usr/conf/isgw.tones');
			$credentials = $tones_loaded[$tones];
		}
		break;
	default:
		break;
}
	
foreach(array_keys(HelperPstn::getTonesCredentials()) as $key) {
	$response["id_$key"] = $credentials[$key];
}

echo Helper::jsonEncode($response);
?>
